import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
import seaborn as sns
import plotly.express as px
import plotly.graph_objects as go
import datetime as dt
from sklearn.metrics import accuracy_score, confusion_matrix, classification_report, f1_score
from sklearn.linear_model import LogisticRegression
from sklearn.ensemble import RandomForestClassifier
from sklearn.svm import SVC
from sklearn.tree import DecisionTreeClassifier
from xgboost import XGBClassifier
import xgboost as xgb

from sklearn.model_selection import train_test_split
import warnings

warnings.filterwarnings('ignore')


transData = pd.read_csv('Data/Book1.csv', encoding='latin-1')
transData.head(30)  # view first rows of the dataset

transData.tail(10)  # view last rows of the dataset
transData.describe(include='all')
transData.shape  # view the no.of rows and no.of columns in the dataset

transData.info()
transData['DATE'] = pd.to_datetime(transData['DATE'])
transData.info()
transData.Invoice_No.nunique()  # no.of unique values in Invoice_No column

transData.CustomerID.nunique()  # no.of unique values in CustomerID column
ucustomer = transData.isnull().sum()  # view the missing values in the dataset
# print(ucustomer)

transData = transData.dropna(subset=['Invoice_No'], axis=0, how='any').reset_index(
    drop=True)  # remove rows which has missing values in Invoice_No column
transData.isnull().sum()
transData = transData.filter(['Invoice_No', 'CustomerID', 'DATE', 'TOTAL_DIS', 'NET_AMOUNT'], axis=1)
transData = transData.sort_values(by=['CustomerID']).reset_index(drop=True)
Data = transData.groupby('CustomerID').agg(FirstPurch=('DATE', 'first'), LastPurch=('DATE', 'last'))
transData.groupby(['CustomerID', 'DATE'])['CustomerID'].count()

Data1 = transData.groupby("CustomerID").agg({"DATE": "nunique"}).rename(columns={'DATE': 'ActiveDays'})

transData1 = pd.merge(Data, Data1, on='CustomerID')

transData = transData.drop_duplicates(subset='CustomerID').reset_index(drop=True)
transData = pd.merge(transData, transData1, on='CustomerID')
transData['DaysFirstPurch'] = (pd.Timestamp('today') - transData['FirstPurch']).dt.days
transData['DaysLastPurch'] = (pd.Timestamp('today') - transData['LastPurch']).dt.days
# average time between purchases
transData['Wavelength'] = (transData['DaysFirstPurch'] - transData['DaysLastPurch']) / transData['ActiveDays']
transData['ChurnFactor'] = transData['DaysLastPurch'] / transData['Wavelength']
transData = transData.drop(['Invoice_No', 'DATE', 'TOTAL_DIS', 'NET_AMOUNT'], axis=1)
transData['CHURN'] = ' '
# xgb_tuned = XGBClassifier()
# xgb_tuned_gs = GridSearchCV(xgb_tuned, param_grid_xgb, cv=3, scoring='f1', n_jobs=-1, verbose=1)
# xgb_tuned_gs.fit(X_train, y_train)

# make predictions with the trained model on the test set
# y_pred_xgb_tuned = xgb_tuned_gs.predict(X_test)
# y_pred_xgb_tuned_prob = xgb_tuned_gs.predict_proba(X_test)

transData['CHURN'] = 0
transData.loc[((transData['Wavelength']) > 10 & (transData['ChurnFactor'] > 2)) | (
            (transData['Wavelength']) < 10 & (transData['ChurnFactor'] > 5)), 'CHURN'] = 1

# transData = transData.loc[transData['CHURN'] == 1]

transData = transData.filter(['CustomerID', 'CHURN'], axis=1)
ReadFinalChurn = transData[(transData["CustomerID"] == 1002)]


# GO WITH XGB

from numpy import loadtxt
from xgboost import XGBClassifier
from sklearn.model_selection import train_test_split
from sklearn.metrics import accuracy_score

# split data into X and y
X = transData[['CustomerID']]
Y = transData['CHURN']
# split data into train and test sets
seed = 7
test_size = 0.33
X_train, X_test, y_train, y_test = train_test_split(X, Y, test_size=test_size, random_state=seed)
# fit model no training data
model = XGBClassifier()
model.fit(X_train, y_train)

# make predictions for test data

FinalChurn = ReadFinalChurn['CHURN'].tolist()
print  (FinalChurn)
if (FinalChurn == [1]):
    print("CHURN")

else:
    print("NON CHURN")






